package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

public class Fak extends AbstractBehavior<Fak.Message> {

    public interface Message {};

    public record FakMessage(int val, ActorRef<FakCont.Message> cust) implements Message {  }

    public static Behavior<Message> create() {
        return Behaviors.setup(Fak::new);
    }


    private Fak(ActorContext<Message> context) {
        super(context);
    }

    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(FakMessage.class, this::onFakMessage)
                .build();
    }

    private Behavior<Message> onFakMessage(FakMessage msg) {
        if(msg.val == 0) {
            msg.cust.tell(new FakCont.FakContMessage(1));
        } else {
            ActorRef<FakCont.Message> cont = this.getContext().spawnAnonymous(FakCont.create(msg.val, msg.cust));
            this.getContext().getSelf().tell(new FakMessage(msg.val - 1, cont));
        }
        return this;
    }
}
