package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.AbstractBehavior;
import akka.actor.typed.javadsl.ActorContext;
import akka.actor.typed.javadsl.Behaviors;
import akka.actor.typed.javadsl.Receive;

public class FakCont extends AbstractBehavior<FakCont.Message> {

    private final int val;
    private final ActorRef<Message> cust;

    public interface Message {};

    public record FakContMessage(int arg) implements Message {  }

    public static Behavior<Message> create(int val, ActorRef<Message> cust) {
        return Behaviors.setup(context -> new FakCont(context, val, cust));
    }



    private FakCont(ActorContext<Message> context, int val, ActorRef<Message> cust) {
        super(context);
        this.val = val;
        this.cust = cust;
    }

    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(FakContMessage.class, this::onFakContMessage)
                .build();
    }

    private Behavior<Message> onFakContMessage(FakContMessage msg) {
        this.cust.tell(new FakContMessage(this.val * msg.arg));
        return this;
    }
}
